<?php
if(!$contentData) {
    $contentData = [
        "items" => [
            [
                "title" => "",
                "icd" => "",
                "coa" => "",
                "detail" => "",
                "plan" => "",
            ]
        ]
    ];
}
$formID = rand(0, 100000);
?>
<div id="dxSection">
    <h3 class="stag-popup-title mb-2 border-bottom-0 pb-1">
        <span>Current Problems / Focus Areas</span>
        <a href="#" onclick="return closeStagPopup()"
           class="ml-auto text-secondary">
            <i class="fa fa-times-circle"></i>
        </a>
    </h3>

    <input type="hidden" name="data" value="{{json_encode($contentData)}}">

    <table class="table table-sm table-bordered mb-2 table-edit-sheet">
        <thead>
        <tr class="bg-light">
            <th class="border-bottom-0">Title</th>
            <th class="border-bottom-0">ICD</th>
            <th class="border-bottom-0">Chr/Act.</th>
            <th class="border-bottom-0 w-35">Detail</th>
            <th class="border-bottom-0 w-35">Plan</th>
            <th class="border-bottom-0"></th>
        </tr>
        </thead>
        <tbody>
        <tr v-for="(item, index) in items">
            <td><input type="text" class="form-control form-control-sm canvas-dx-title" v-model="item.title"></td>
            <td><input type="text" class="form-control form-control-sm" v-model="item.icd"></td>
            <td>
                <select v-model="item.coa" class="form-control form-control-sm pl-1" required>
                    <option value="">-- select --</option>
                    <option value="Chronic" selected>Chronic</option>
                    <option value="Acute">Acute</option>
                </select>
            </td>
            <td><input type="text" class="form-control form-control-sm" v-model="item.detail"></td>
            <td><input type="text" class="form-control form-control-sm" v-model="item.plan"></td>
            <td class="px-2">
                <a href="#" v-on:click.prevent="removeItem(index)"
                   class="on-hover-opaque text-danger mt-1 d-inline-block">
                    <i class="fa fa-trash-alt"></i>
                </a>
            </td>
        </tr>
        </tbody>
    </table>

    <div class="form-group my-2">
    <button class="btn btn-sm btn-default text-primary border border-primary mr-2"
            v-on:click.prevent="addItem()"
    >+ New Entry</button>
    </div>

</div>
<script>
    (function() {
        function init() {
            window.clientDXApp = new Vue({
                el: '#dxSection',
                data: {
                    items: <?= json_encode($contentData['items']) ?>
                },
                mounted: function() {

                },
                watch: {
                    $data: {
                        handler: function(val, oldVal) {
                            $(this.$el).closest('#dxSection').find('[name="data"]').val(JSON.stringify({
                                items: this.cleanArray(this.items)
                            }));
                        },
                        deep: true
                    }
                },
                methods: {
                    addItem: function() {
                        this.items.push({
                            title: '',
                            icd: '',
                            coa: '',
                            detail: '',
                            plan: '',
                        });
                        Vue.nextTick(function() {
                            $('.canvas-dx-title').last().focus();
                        });
                    },
                    removeItem: function(_index) {
                        this.items.splice(_index, 1);
                    },
                    cleanArray: function(_source) {
                        let plItems = [], plObject = {};
                        for (let x=0; x<_source.length; x++) {
                            plObject = {};
                            for (let y in _source[x]) {
                                if(_source[x].hasOwnProperty(y)) {
                                    plObject[y] = _source[x][y];
                                }
                            }
                            plItems.push(plObject);
                        }
                        return plItems;
                    }
                }
            });
        }
        addMCInitializer('client-dx-{{ $patient->uid }}', init);
    })();
</script>
